(function(){
var _verbose = false;

var c2Runtime;

var step = -1;
var started = false;
var audioBuffer = [];
var timerUpdate;


var listOfAllSong = ["321.ogg","3210.ogg","bonmal.ogg","bonus_towertimer.ogg","butt_level.ogg","butt_menu.ogg","cancel_tower_inshop.ogg","clickonfey.ogg","coin_in.ogg","coin_tap.ogg","coon_create_gem.ogg","enemy_attack.ogg","enemy_baloon_onscreen.ogg","enemy_baloon_paf.ogg","enemy_bobsleg_slide.ogg","enemy_bomber_explosion.ogg","enemy_bomber_onscreen.ogg","enemy_bonevault_jump.ogg","enemy_clawmachine_stop.ogg","enemy_clawmachine_up.ogg","enemy_die_1.ogg","enemy_die_2.ogg","enemy_die_3.ogg","enemy_die_4.ogg","enemy_kart_loop.ogg","enemy_ladder.ogg","enemy_looseflag.ogg","enemy_metalleuxdie.ogg","enemy_metalleuxloop.ogg","enemy_metalleuxloop_fast.ogg","enemy_mudcar_crash.ogg","enemy_mudcar_loop.ogg","enemy_plouf.ogg","enemy_pogo_jump.ogg","enemy_portal_across.ogg","enemy_portal_opening.ogg","enemy_scooter_hit.ogg","enemy_scooter_loop.ogg","enemy_scooter_throw.ogg","enemy_surfer_phase1.ogg","enemy_surfer_phase2.ogg","enemy_surfer_phase3_loop.ogg","enemy_swampy_attack.ogg","enemy_swampy_die.ogg","enemy_swampy_onscreen.ogg","enemy_throw.ogg","enemy_wastchild_bigjump.ogg","enemy_wastchild_minijump.ogg","gameover_phase1.ogg","gameover_phase2.ogg","gameover_phase3.ogg","gameover_phase4.ogg","gameover_winobject.ogg","hammer_splat.ogg","jackpot.ogg","music_game_over.ogg","music_ingame.ogg","music_menu.ogg","newrecord.ogg","pets_attack_capkid.ogg","pets_attack_chomper.ogg","pets_attack_docboom_phase1.ogg","pets_attack_docboom_phase2.ogg","pets_attack_dragon.ogg","pets_attack_dynamole.ogg","pets_attack_eggbroke.ogg","pets_attack_eggthrow.ogg","pets_attack_fireball_hitenemy.ogg","pets_attack_fireball_throw.ogg","pets_attack_flammingmoose.ogg","pets_attack_hitenemyhelmet.ogg","pets_attack_hitenemyloosehelmet.ogg","pets_attack_iceball_hitenemy.ogg","pets_attack_iceball_throw.ogg","pets_attack_kitsune.ogg","pets_attack_magnet.ogg","pets_attack_mecadrake.ogg","pets_attack_minicorne.ogg","pets_attack_nerisson.ogg","pets_attack_octopussy.ogg","pets_attack_pouncer_phase1.ogg","pets_attack_pouncer_phase2.ogg","pets_attack_pricedelu.ogg","pets_attack_seadragon.ogg","pets_attack_skunk.ogg","pets_attack_umbrella.ogg","pets_broke_crystalshield.ogg","pets_erase.ogg","pets_magnet.ogg","pets_new_chomper.ogg","pets_new_coon.ogg","pets_new_crystalshield.ogg","pets_new_dragon.ogg","pets_new_drop.ogg","pets_new_dynamole.ogg","pets_new_flamingmoose.ogg","pets_new_hedgie.ogg","pets_new_iceberg.ogg","pets_new_inwater.ogg","pets_new_mecadrake.ogg","pets_new_minicorne.ogg","pets_new_octopussy.ogg","pets_new_pouncer.ogg","pets_new_shield_basic.ogg","pets_new_shield_metal.ogg","pets_new_teendragon.ogg","pets_new_umbrella.ogg","pets_new_veteran.ogg","pets_skunk.ogg","shop_come.ogg","shop_goout.ogg","speeddown.ogg","speedup.ogg","takemagicwand.ogg","take_gem.ogg","take_gem_added.ogg","victory_coin.ogg","victory_full_coin.ogg","victory_star.ogg","wrong.ogg"];
var category_list = [];

fillArrayCategory();

eventToFire.registerEvent("c2LayoutChange",
	function (args){
		if(!started){
			c2Runtime = cr_getC2Runtime();
			started = true;
			nextStep();
		}
	}
);

function update(){
	for (var i = 0; i < audioBuffer.length; i++) {
		if(audioBuffer[i].isLoadedAndDecoded()){ //audioBuffer[i].isLoaded()
			if(_verbose) console.log("sound end load & decoded:",audioBuffer[i].src);
			audioBuffer.splice(i, 1);
		}
	};

	if(audioBuffer.length == 0){
		nextStep();
	}
}

function nextStep(){
	step +=1;
	clearInterval(timerUpdate);

	if(category_list[step]){
		for (var i = category_list[step].length - 1; i >= 0; i--) {
			if(_verbose) console.log("sound start load:",category_list[step][i]);
			audioBuffer.push(c2Runtime.audioInstance.getAudioBuffer(c2Runtime.files_subfolder+category_list[step][i]));
		};

		timerUpdate = setInterval(update,100);

	}else{
		if(_verbose) console.log("all Sound loaded & decoded");
	}
}

function fillArrayCategory(){
	var firstLoad = [];
	var arrayWihtoutMusic = [];
	var musicInGame = [];
	var musicGameOver = [];
	var name;

	for (var i = 0; i < listOfAllSong.length; i++) {
		name = listOfAllSong[i].replace(/\.[a-z]+/,"");
		
		if(name == "butt_level" || name == "butt_menu" || name == "music_menu"){
			firstLoad.push(listOfAllSong[i]);
		}
		else if(name == "music_ingame"){
			musicInGame.push(listOfAllSong[i]);
		}
		//list of gameOverSong
		else if(name == "music_game_over" || name == "defeat_sound" || name == "defeat" || name == "victory_game_over" || name == "looser" || name == "gameOver_defeat" || name == "gameOver"){
			musicGameOver.push(listOfAllSong[i]);
		}
		else {
			arrayWihtoutMusic.push(listOfAllSong[i]);
		}
	};
	category_list.push(firstLoad);
	category_list.push(arrayWihtoutMusic);
	category_list.push(musicInGame);
	category_list.push(musicGameOver);
}

}())

